#ifndef RC_DYNAMICS_API_VERSION_H_
#define RC_DYNAMICS_API_VERSION_H_

/// project version as major.minor.patch string
#define RC_DYNAMICS_API_VERSION "0.10.0"
/// project version as integer: major * 10000 + minor * 100 + patch
#define RC_DYNAMICS_API_VERSION_INT 1000
#define RC_DYNAMICS_API_VERSION_MAJOR 0
#define RC_DYNAMICS_API_VERSION_MINOR 10
#define RC_DYNAMICS_API_VERSION_PATCH 0
/// package version as string, possibly with git commit: v1.2.3+4+g56789abc
#define RC_DYNAMICS_API_PACKAGE_VERSION "0.10.0"

///runtime versions, where the above values are linked into a lib and therefore reflect the version
///of the library itself (not the version of the header at compile time of the user code)
const char* rc_dynamics_api_runtime_project_version();
const char* rc_dynamics_api_runtime_package_version();
int rc_dynamics_api_runtime_version_int();
int rc_dynamics_api_runtime_version_major();
int rc_dynamics_api_runtime_version_minor();
int rc_dynamics_api_runtime_version_patch();

///Check consistency of runtime vs compile-time version number. I.e. the header used
///for compilation was from the same version as the linked library.
inline bool rc_dynamics_api_check_version_consistency(bool major_minor_only)
{
  return rc_dynamics_api_runtime_version_major() == RC_DYNAMICS_API_VERSION_MAJOR &&
         rc_dynamics_api_runtime_version_minor() == RC_DYNAMICS_API_VERSION_MINOR &&
         (major_minor_only ||
          rc_dynamics_api_runtime_version_patch() == RC_DYNAMICS_API_VERSION_PATCH);
}


#endif
